=== debian/control ===
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

Source: hue
Section: misc
Priority: extra
Maintainer: Cloudera Inc. <https://issues.cloudera.org>
Build-Depends: debhelper (>= 7.0.50~), python2.4-dev | python2.5-dev | python2.6-dev | python2.7-dev, libxml2-dev, libxslt1-dev, zlib1g-dev, libsqlite3-dev, libldap2-dev, libsasl2-dev, libmysqlclient-dev, make, python-setuptools, libkrb5-dev, libgmp3-dev, libffi-dev, libtidy-dev, libssl-dev, libgmp-dev
Depends: hadoop, hive, bigtop-utils (>= 0.7), libsasl2-modules, libsasl2, libsqlite3, zlib1g, libxslt1, libxml2, libgmp3, libffi, libtidy, libssl, libgmp
Standards-Version: 3.8.0
Homepage: http://github.com/cloudera/hue

Package: hue
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, ${build:SYS-PYTHON}, libsasl2-modules-gssapi-mit, libxslt1.1, make
Conflicts: cloudera-desktop
Replaces: hue-about, hue-filebrowser, hue-help, hue-jobbrowser, hue-jobsub, hue-metastore, hue-oozie, hue-proxy, hue-shell, hue-useradmin, hue-beeswax, hue-common, hue-doc, hue-hbase, hue-impala, hue-pig, hue-plugins, hue-rdbms, hue-search, hue-security, hue-spark, hue-sqoop, hue-zookeeper, hue-server
Description: The hue metapackage
 Hue is a browser-based desktop interface for interacting with Hadoop.
 It supports a query editor, file browser, job tracker interface, cluster health monitor, and more.
